
Foreman - Bug #13849

updating a host's facet should not require the facet id to be included in facet params

02/23/2016 08:18 AM - Thomas McKay

Status: Closed   

Priority: Normal   

Assignee: Shimon Shtein   

Category: API   

Target version: 1.11.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1312107 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3254

  

Description

Instead of requiring an update to a host's facet attributes to include the ID of the facet, look up the needed ID in the API controller

and add to params. Facet IDs are not, imho, a user-facing aspect that needs to be exposed.

{

    host_id: 123,

    host: {

        name: "abc.example.com",

        content_facet_attributes: {

            id: 1234,    <---- REMOVE

            lifecycle_environment_id: 12,

            content_view_id: 12

        },

        subscription_facet_attributes: {

            id: 1234,    <---- REMOVE

            service_level: "Premium" 

         }

    }

}

Related issues:

Blocks Katello - Feature #11435: Host Unification Tracker New

Associated revisions

Revision ec76b009 - 03/09/2016 09:44 AM - Shimon Shtein

Fixes #13849 - Now the facets will not require id attribute for update

Revision 91b4e718 - 04/18/2016 01:45 PM - Shimon Shtein

Fixes #13849 - Now the facets will not require id attribute for update

(cherry picked from commit ec76b0092f9af5b8f7e2e02777f376b6b6e0d711)

History

#1 - 02/24/2016 07:45 AM - Shimon Shtein

Which method did you use, PUT or PATCH?

PUT is full update, so I would expect the id to be there, but in PATCH I don't think you have to specify the id (or any other field that you don't want to

update for that matter).

#2 - 02/25/2016 01:04 PM - Thomas McKay

I used apipie so whatever is present there (PUT I assume)

#3 - 02/25/2016 01:18 PM - Justin Sherrill

I see the same issue with PATCH /api/v2/hosts/3
This works fine:  {"subscription_facet_attributes": {"id": 8,"service_level": "foo"}}

But this does not: {"subscription_facet_attributes": {"service_level": "foo"}}

It appears ends up trying to create a new subscription facet with a null id.

#4 - 02/25/2016 01:23 PM - Justin Sherrill

- Bugzilla link set to 1312107

#5 - 02/25/2016 01:39 PM - Justin Sherrill

- Blocks Feature #11435: Host Unification Tracker added

#6 - 02/29/2016 10:09 AM - Shimon Shtein

- Assignee set to Shimon Shtein

#7 - 03/01/2016 07:02 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3254 added

#8 - 03/09/2016 10:04 AM - Shimon Shtein

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset ec76b0092f9af5b8f7e2e02777f376b6b6e0d711.

#9 - 03/09/2016 10:37 AM - Dominic Cleal

- translation missing: en.field_release set to 141
